/****************************************************
 Test for DSP-to-PCIC access for TP64xx boards.
 (C) MicroLAB Systems, 1997-2002


   Description:
   ------------
	This demo continuously on-board PCIC from DSP.


   TORNADO platform:
   -----------------
	This demo does not utilize any host TORNADO resources, however it requires
	that the board is plugged into host PCI slot.

	TI CCS6000 tools are required to recompile this demo. Either 
	TP6COFF.EXE utility or MIRAGE JTAG emulator are required to 
	upload code to the on-board DSP environment.

  Copyright:
  ----------
	This demo is distributed free of charge and as it is without
	any obligation from MicroLAB Systems.


  Demo and Signal Parameters:
  ---------------------------
    On-board configuration switches:
        - host mode
	  	- no BOOT mode
*****************************************************/

#define		__TP6X_SELECT_TP64XX__	1

#include "c6x_def.h"
#include "tp6x_dsp.h"


main()
{ 
	unsigned imbx[4],n,j,jj,rb,pass;

	// initialize DSP EMIF areas
   	TP6X_init_dsp_emif();

	// disable occasional PCI-bus mastering
	TP6X_set_amwren_rg(0);

	// disable transfer counts
   	TP6X_set_pcic_agcsts(0);	

   	j=0;
	pass=0;
   	while(1)
    {
		// use PIOX/SIOX RESET control as progress indicators
       	TP6X_set_pxsx_reset_rg(0x7);	
       	TP6X_set_pxsx_reset_rg(0);	

		// for even pass# use 32-bit PCIC access, for odd pass# use 16-bit PCIC access
		if((pass%2)==0)
			TP6X_SET_PCIC_FMT_W32;
		else
			TP6X_SET_PCIC_FMT_W16;

		pass++;

       	jj=j;
       	for(n=0;n<4;n++)
		{
	   		imbx[n] = TP6X_pcic_imbx(n);
	   		TP6X_set_pcic_ombx(n,imbx[n]+jj);
	   		jj++;
	 	}

       	jj=j;
       	for(n=0;n<4;n++)
		{ 
			rb = TP6X_pcic_ombx(n);
           	if(   	(n!=3 && rb!=(imbx[n] +jj))
	      		|| 	(n==3 && (rb&0xffffff)!=((imbx[n] +jj)&0xffffff))
              )
                goto error;
	   		jj++;
	 	}
       	j=jj;

       	TP6X_set_pcic_mwar(jj++);
       	TP6X_set_pcic_mrar(jj++);

       	jj=j;

       	if(TP6X_pcic_mwar()!= ((jj++) & 0xfffffffc)) goto error;
       	if(TP6X_pcic_mrar()!= ((jj++) & 0xfffffffc)) goto error;
       	j=jj;

    }

error:
    while(1);
}



