/****************************************************
 Test for DSP-to-PCIC access for TP6x boards.
 (C) MicroLAB Systems, 1997-2000


   Description:
   ------------
	This demo continuously on-board PCIC from DSP.


   TORNADO platform:
   -----------------
	This demo does not utilize any host TORNADO resources, however it requires
	that the board is plugged into host PCI slot.

	TI CCS6000 tools are required to recompile this demo. Either 
	TP6COFF.EXE utility or MIRAGE JTAG emulator are required to 
	upload code to the on-board DSP environment.

  Copyright:
  ----------
	This demo is distributed free of charge and as it is without
	any obligation from MicroLAB Systems.


  Demo and Signal Parameters:
  ---------------------------
        on-board configuration switch:
          - host mode
	  - no BOOT mode
*****************************************************/

#include "c6x_def.h"
#include "tp6x_dsp.h"


main()
{ unsigned imbx[4],n,j,jj,rb;

	// initialize DSP EMIF areas
	// configure on-board RAM as SBSRAM for TP6202/TP6203 (has no matter for this test)
   TP6X_init_dsp_emif(TP6X_XMEM_SBSRAM);

   j=0;
   TP6X_set_pcic_agcsts(0);	// disable transfer counts


   while(1)
    {
       TP6X_set_px_run(ON);	// use this as synchro pulses
       TP6X_set_px_run(OFF);

       jj=j;
       for(n=0;n<4;n++)
         {
	   imbx[n] = TP6X_pcic_imbx(n);
	   TP6X_set_pcic_ombx(n,imbx[n]+jj);
	   jj++;
	 }

       jj=j;
       for(n=0;n<4;n++)
         { rb = TP6X_pcic_ombx(n);
           if(   (n!=3 && rb!=(imbx[n] +jj))
	      || (n==3 && (rb&0xffffff)!=((imbx[n] +jj)&0xffffff))
             )
                goto error;
	   jj++;
	 }
       j=jj;


       TP6X_set_pcic_mwar(jj++);
       TP6X_set_pcic_mrar(jj++);

       jj=j;

       if(TP6X_pcic_mwar()!= ((jj++) & 0xfffffffc)) goto error;
       if(TP6X_pcic_mrar()!= ((jj++) & 0xfffffffc)) goto error;
       j=jj;


    }

  error:
    while(1);

}



