/****************************************************
 WDT test for TP6x boards.
 (C) MicroLAB Systems, 1997-2000


   Description:
   ------------
	This demo continuously reboots DSP on the WDT expiration. The
	DSP RESET LED will flash with the period about 1.5 sec.


   TORNADO platform:
   -----------------
	This demo does not utilize any host TORNADO resources
	and runs in either stand-alone mode or in case the board
	is installed into the PCI slot and is configured to run in
	stand-alone mode. TI CCS6000 tools are required to recompile 
	this demo. Either TP6COFF.EXE utility or MIRAGE JTAG emulator 
	are required to upload code to the on-board DSP environment.

  Copyright:
  ----------
	This demo is distributed free of charge and as it is without
	any obligation from MicroLAB Systems.


  Demo and Signal Parameters:
  ---------------------------
        on-board configuration switch:
          - SA-mode
	  - no BOOT mode
	  - emulator must be put into the RUN FREE mode after
	    uploading the exection code


*****************************************************/

#include "c6x_def.h"
#include "tp6x_dsp.h"


main()
{ 
	// initialize DSP EMIF areas
	// configure on-board RAM as SBSRAM for TP6202/TP6203 (has no matter for this test)
   TP6X_init_dsp_emif(TP6X_XMEM_SBSRAM);

   TP6X_set_wdt_enable(ON);
   while(1);
}



