/******************************************************************************
   TORNADO-P64xx Demo Utility. DSP on-chip GPIO Test. rev.1A
   (C) MicroLAB Systems, 1999-2002


   Description:
   ------------
	This demo continuously runs '1' thru 10-bit DSP on-chip GPIO, 
	which is available via JP13	connector of TORNADO-E64xx board.

	!!!CAUTION!!!
		This demo does not run for TORNADO-P62/P620x/P67 boards,
		which do not provide 'C620x/C670x DSP on-chip GPIO.


   TORNADO platform:
   -----------------
	This demo does not utilize any host resources.
	TI CCS6000 tools are required to recompile this demo. Either 
	TP6COFF.EXE utility or MIRAGE JTAG emulator are required to 
	upload code to the on-board DSP environment.

   Copyright:
   ----------
	This demo is distributed free of charge and as it is without
	any obligation from MicroLAB Systems.


   Demo and Signal Parameters:
   ---------------------------
        on-board configuration switch:
          	- SA-mode or host mode
	  		- no BOOT mode
******************************************************************************/
#define		__TP6X_SELECT_TP64XX__	1

#define	ML_OFF	0
#define	ML_ON	1

#include	<math.h>
#include 	"c6x_def.h"
#include 	"tp6x_dsp.h"


void main()
{
	int i,d;

	// initialize DSP EMIF areas
   	TP6X_init_dsp_emif();

	// TP64xx on-board JP13 DSP GPIO connector includes DSP on-chip GPIO-0/3 and 
	// GPIO-8..15 pins. Other are reserved. Enable and configure them as the outputs.
	C6X_SET_GPIO_ENABLE_RG(0xff09);
	C6X_SET_GPIO_DIR_RG(0xff09);
	C6X_SET_GPIO_DATA_RG(0);

	while(1)
	{
		// run '1' thru DSP GPIO-0/3/8..15 pins
	   	for(i=0,d=1;i<=16;i++, d<<=1)
		{
			if(i==0 || i==3 || (i>=8)) 
					C6X_SET_GPIO_DATA_RG(d);
	 	}
	}
}
