/****************************************************
  DPRAM memory test for TP64xx f/w rev.1A-1 and rev.1A-2 boards.
  (C) MicroLAB Systems, 1997-2004

  Notes:
  	1. This test/demo runs for TP64xx boards with f/w rev.1A-1 and rev.1A-2.
	2. This demo automatically detects the DPRAM capacity.
	3. This demo fails for TP64xx boards with f/w rev.1A.
	   Use the TP64XX_DPRAM_128K.C test/demo for TP64xx boards
	   with f/w rev.1A.
*****************************************************/

#define		__TP6X_SELECT_TP64XX__	1

#include <c6x_def.h>
#include <tp6x_dsp.h>

unsigned *ptr ;
unsigned start_data = 0xa596e73b,
         start_data_block;
unsigned mem_inc_data = 0x97b5f3be;
unsigned mem_wr_data;
unsigned pass_counter=0;
unsigned *DMEM_START_PTR,*DMEM_END_PTR;


main()
{
	// initialize DSP EMIF areas
   	TP6X_init_dsp_emif();

	// jump to error loop for f/w rev.1A,
	// since f/w rev.1A does not provide the DPRAM LEN ID
	if(TP6X_REV_ID_IS_REV1A) goto error;

	// set the DPRAM address limits
	DMEM_START_PTR = ((unsigned *) TP6X_DPRAM_SADDR);
	DMEM_END_PTR   = ((unsigned *) TP6X_DPRAM_EADDR);

	// perform infinite testing
   	while(1)
    {
		start_data_block= start_data;

		for(mem_wr_data=start_data, ptr=DMEM_START_PTR;
	        ptr<=DMEM_END_PTR ;
			*ptr++ = mem_wr_data++);

       	start_data += mem_inc_data ;

		start_data=start_data_block;

		for(mem_wr_data=start_data, ptr=DMEM_START_PTR;
	        ptr<=DMEM_END_PTR ;
		   )
   	   	{
        	if(*ptr++ != mem_wr_data++)
				goto error ;
	   	}
        start_data += mem_inc_data ;

     	pass_counter++;	// increment the pass counter
    }


error:	// get here on any error
    while(1) ;

}


