/****************************************************
  DPRAM 128Kx32 memory test for TP64xx f/w rev.1A boards.
  (C) MicroLAB Systems, 1997-2004

  Notes:
  	1. Use the TP64XX_DPRAM.C test/demo for TP64xx boards
	   with f/w rev.1A-1 and rev.1A-2.
*****************************************************/

#define		__TP6X_SELECT_TP64XX__	1

#include <c6x_def.h>
#include <tp6x_dsp.h>

unsigned *ptr ;

#define RAM_LEN			(TP6X_DPRAM_LEN_512KB/4)
#define	DMEM_START_PTR	((unsigned *) TP6X_DPRAM_SADDR)
#define	DMEM_END_PTR	((unsigned *) (TP6X_DPRAM_SADDR+RAM_LEN*4-1))


unsigned start_data = 0xa596e73b,
         start_data_block;
unsigned mem_inc_data = 0x97b5f3be;
unsigned mem_wr_data;
unsigned pass_counter=0;


main()
{
	// initialize DSP EMIF areas
   	TP6X_init_dsp_emif();

   	while(1)
    {
		start_data_block= start_data;

		for(mem_wr_data=start_data, ptr=DMEM_START_PTR;
	        ptr<=DMEM_END_PTR ;
			*ptr++ = mem_wr_data++);

       	start_data += mem_inc_data ;

		start_data=start_data_block;

		for(mem_wr_data=start_data, ptr=DMEM_START_PTR;
	        ptr<=DMEM_END_PTR ;
		   )
   	   	{
        	if(*ptr++ != mem_wr_data++)
				goto error ;
	   	}
        start_data += mem_inc_data ;

     	pass_counter++;	// increment the pass counter
    }


error:	// get here on any error
    while(1) ;

}


