/****************************************************
  SBSRAM 256Kx32 memory test for TP6x boards.
  (C) MicroLAB Systems, 1997-2000

*****************************************************/

unsigned *ptr ;

#include "c6x_def.h"
#include "tp6x_dsp.h"

#define RAM_LEN		0x40000
#define	DMEM_START_PTR	((unsigned *) TP6X_SBSRAM_SADDR)
#define	DMEM_END_PTR	((unsigned *) (TP6X_SBSRAM_SADDR+RAM_LEN*4-1))


unsigned start_data = 0xa596e73b,
         start_data_block;
unsigned mem_inc_data = 0x97b5f3be;
unsigned mem_wr_data;
unsigned pass_counter=0;


main()
{
	// initialize DSP EMIF areas and configure as SBSRAM for TP6202/TP6203
   TP6X_init_dsp_emif(TP6X_XMEM_SBSRAM);

   while(1)
    {
      start_data_block= start_data;

          for(mem_wr_data=start_data, ptr=DMEM_START_PTR;
	      ptr<=DMEM_END_PTR ; *ptr++ = mem_wr_data++);

          start_data += mem_inc_data ;

      start_data=start_data_block;

          for(mem_wr_data=start_data, ptr=DMEM_START_PTR;
	      ptr<=DMEM_END_PTR ;	)
   	   {
             if(*ptr++ != mem_wr_data++) goto error ;
	   }
          start_data += mem_inc_data ;

     pass_counter++;	// increment the pass counter

    }


  error:	// get here on any error
    while(1) ;

}


