/***************************************************************************
  SDRAM 8Mx32 (16MB@CE3 and 16MB@CE2) memory test for TP6202/TP6203 boards.
  (C) MicroLAB Systems, 1997-2000

  notes:
	1. This test runs on TP6202/TP6203 boards only with 8Mx32 SDRAM installed.
	2. 4Mx32 SDRAM banks shll be installed into CE-3 and CE-2 EMIF areas.

****************************************************************************/

unsigned *ptr_ce2, *ptr_ce3 ;

#include "c6x_def.h"
#include "tp6x_dsp.h"

#define RAM_LEN			0x400000
#define	DMEM_START_PTR_CE3	((unsigned *) TP6X_SDRAM_SADDR)
#define	DMEM_END_PTR_CE3	((unsigned *) (TP6X_SDRAM_SADDR+RAM_LEN*4-1))
#define	DMEM_START_PTR_CE2	((unsigned *) TP6X_SDRAM2_SADDR)
#define	DMEM_END_PTR_CE2	((unsigned *) (TP6X_SDRAM2_SADDR+RAM_LEN*4-1))

unsigned start_data_ce2 = 0xa596e73b,
	 start_data_ce3 = 0xe196135f,
	 start_data_block_ce2,
	  start_data_block_ce3;
unsigned mem_inc_data_ce2 = 0x97b5f3be, 
	 mem_inc_data_ce3 = 0x7823ab9b;
unsigned mem_wr_data;
unsigned pass_counter=0;


main()
{

	// check for this is TP6202 or TP6203 board
   if(!TP6202_TP6203_BOARD) goto error;

	// initialize DSP EMIF areas and configure as SDRAM for TP6202/TP6203
   TP6X_init_dsp_emif(TP6X_XMEM_SDRAM);

   while(1)
    {

	// fill-in SDRAM at CE-2
      start_data_block_ce2= start_data_ce2;

          for(mem_wr_data=start_data_ce2, ptr_ce2=DMEM_START_PTR_CE2;
	      ptr_ce2<=DMEM_END_PTR_CE2 ; *ptr_ce2++ = mem_wr_data++);

          start_data_ce2 += mem_inc_data_ce2 ;

	// fill-in SDRAM at CE-3
      start_data_block_ce3= start_data_ce3;

          for(mem_wr_data=start_data_ce3, ptr_ce3=DMEM_START_PTR_CE3;
	      ptr_ce3<=DMEM_END_PTR_CE3 ; *ptr_ce3++ = mem_wr_data++);

          start_data_ce3 += mem_inc_data_ce3 ;


	// verify SDRAM at CE-2
      start_data_ce2=start_data_block_ce2;

          for(mem_wr_data=start_data_ce2, ptr_ce2=DMEM_START_PTR_CE2;
	      ptr_ce2<=DMEM_END_PTR_CE2 ;	)
   	   {
             if(*ptr_ce2++ != mem_wr_data++) goto error ;
	   }
          start_data_ce2 += mem_inc_data_ce2 ;

	// verify SDRAM at CE-3
      start_data_ce3=start_data_block_ce3;

          for(mem_wr_data=start_data_ce3, ptr_ce3=DMEM_START_PTR_CE3;
	      ptr_ce3<=DMEM_END_PTR_CE3 ;	)
   	   {
             if(*ptr_ce3++ != mem_wr_data++) goto error ;
	   }
          start_data_ce3 += mem_inc_data_ce3 ;



     pass_counter++;	// increment the pass counter

    }


  error:	// get here on any error
    while(1) ;

}


