/**************************************************************************
  SIOX-A rev.C Parallel Data Bus Test for TP64xx.
  (C) MicroLAB Systems, 1999-2002

	Description:
	------------	
		This test checks R/W buffers for parallel data bus of SIOX-A rev.C
		interface.

			!!!CAUTION!!!
		       	DO NOT APPLY ANY OSCILLOSCOPE NODES to the PIOX
       			DATA BUS! (written data must stay precharged on
       			SIOX rev.C parallel data bus buffers).

		External grounding jumper is required for SX_READY input pin of
		SIOX-A rev.C interface connector, which must be installed into
		pin #17 of on-board JP2 connector in order to permanently confirm
		SIOX rev.C parallel data bus cycles.

		TIMER-0 output is used as the progress indicator and is toggling 
		in case of correct test procurement. In order to enable TM0 output,
		the	following on-board DSP TIMERs configuration switches shall be 
		configured properly:
			- SW5-1 must be set to the 'ON' state


   TORNADO platform:
   -----------------
		This demo does not utilize any host resources.
		TI CCS6000 tools are required to recompile this demo. Either 
		TP6COFF.EXE utility or MIRAGE JTAG emulator are required to 
		upload code to the on-board DSP environment.

  Copyright:
  ----------
		This demo is distributed free of charge and as it is without
		any obligation from MicroLAB Systems.


  Demo and Signal Parameters:
  ---------------------------
        on-board configuration switch:
          	- SA-mode or host mode
	  		- no BOOT mode
*************************************************************************/
#define		__TP6X_SELECT_TP64XX__	1

#include "c6x_def.h"
#include "tp6x_dsp.h"

#define TM_OUT_0  0
#define TM_OUT_1  4



main()
{
	unsigned  d, dr, i, count;

	// initialize DSP EMIF areas
   	TP6X_init_dsp_emif();

   	count=0;
   	*C6X_TM0_CONTROL = 0;

   	while(1)
    {
		// toggle TM0 output as the progress indicator.
     	if(count==0)
	    { 
			*C6X_TM0_CONTROL = TM_OUT_0;
	      	count++;
	    }
       	else 
		{ 
			*C6X_TM0_CONTROL = TM_OUT_1;
	      	count=0;
	    }

		// run '1' over all D0..7 bits of SIOX-A rev.C parallel data bus
		for(d=1, i=0; i<8 ; i++)
		{ 
			TP6X_set_sioxa_revc_rg(0,d);
			dr = TP6X_get_sioxa_revc_rg(0);
			if(dr!=d) goto error;
	  		d <<= 1;
		}

    }

error:
	// get here on any error condition
    while(1);
	
}



