
/*

	ECC test for TP6x.

*/

#include <stdio.h>
#include <dos.h>
#include <stdlib.h>

#include <ips_ut.h>

#include "tp6x_h.h"

char err_mess[100];

#define BOARD_ID	0

int boards;
unsigned long _io0,_io1, _io3, _io4;
unsigned dev_id, index, ecc[5];
char _io0_name[40],_io1_name[40],_io3_name[40],_io4_name[40], dev_name[40];

 main()

 { int r,i;
   unsigned x;
   unsigned long ulx;
   BYTE b;


   printf("\nECC test for TORNADO-P6x v.2.0\n");
   printf("(C) MicroLAB Systems,2000 \n");
   if(TP6X_open()!=TP6X_OK)
      {
	 exit_err:
	    TP6X_last_err_message(err_mess);
            printf("error: %i  (%s)\n",TP6X_last_err(),err_mess);
	goto exit;
      }
   printf("boards installed: %i.  Selecting board #0...\n", TP6X_boards());

   TP6X_sel_board_id(BOARD_ID);
   TP6X_board_info(BOARD_ID,&dev_id,&index,NULL,NULL,&_io0,&_io1,NULL,&_io3,&_io4);
   TP6X_dev_name(dev_name);
   TP6X_area_alloc_name(TP6X_PCIC_AREA,_io0_name);
   TP6X_area_alloc_name(TP6X_ECC_AREA, _io1_name);
   TP6X_area_alloc_name(TP6X_DPM_AREA, _io3_name);
   TP6X_area_alloc_name(TP6X_HIF_AREA, _io4_name);
   if(TP6X_err_flag()) goto exit_err;

   printf("TP6x device id = %x (%s)     index=%x\n",
	   dev_id, dev_name, index);
   printf("TP6x AMCC registers: %lxH (%s)\n",_io0,_io0_name);
   printf("TP6x ECC area      : %lxH (%s)\n",_io1,_io1_name);
   printf("TP6x DPRAM area    : %lxH (%s)\n",_io3,_io3_name);
   printf("TP6x Host I/O area : %lxH (%s)\n",_io4,_io4_name);


   printf("\npress ESC to abort scanning areas ...\n\n");

   TP6X_SET_MRESET;
   TP6X_SET_SMP_MODE_SPA;
   TP6X_SET_SMP0_PAGE(0);
   TP6X_SET_EMU_SEL_ECC;

   while(1)
     {
             if( key_pressed() && read_char()==KEY_ESC)
	       {
	         printf("\nUser aborted. status: OK\n\n");
	         goto exit;
	       }
	       	
	TP6X_SET_EMU_SEL_ECC;
	if(TP6X_EMU_SEL_RG_DATA!=TP6X_EMU_SEL_ECC)
	  { printf("cannot configure EMU to ECC\n");
	    goto exit;
	  }
	TP6X_CLR_ECC_ERR;
	if(TP6X_ECC_ERR_DATA!=0)
	  { printf("cannot clear ECC-error #1\n");
	    goto exit;
	  }
	TP6X_ECC_RESET;

                //--- read/write to the ECC registers
	TP6X_write_word(TP6X_ECC_AREA,TP6X_ECC_ECC+0x0,0);
	TP6X_write_word(TP6X_ECC_AREA,TP6X_ECC_ECC+0x2,0);
	TP6X_write_word(TP6X_ECC_AREA,TP6X_ECC_ECC+0x4,0);
	TP6X_write_word(TP6X_ECC_AREA,TP6X_ECC_ECC+0x8,0);
	TP6X_write_word(TP6X_ECC_AREA,TP6X_ECC_ECC+0x10,0);

	if(TP6X_ECC_ERR_DATA!=0)
	  { printf("ECC-error on ECC write #1\n");
	    goto exit;
	  }

	ecc[0]= (TP6X_read_word(TP6X_ECC_AREA,TP6X_ECC_ECC+0x0 ))&~0xc0;
	ecc[1]= (TP6X_read_word(TP6X_ECC_AREA,TP6X_ECC_ECC+0x2 ))&~0xe0f0;
	ecc[2]= (TP6X_read_word(TP6X_ECC_AREA,TP6X_ECC_ECC+0x4 ))&~0xffc0;
	ecc[3]= (TP6X_read_word(TP6X_ECC_AREA,TP6X_ECC_ECC+0x8 ))&~0xc000;
	ecc[4]= (TP6X_read_word(TP6X_ECC_AREA,TP6X_ECC_ECC+0x10))&~0xff00;

	if(   ecc[0]!=0
	   || ecc[1]!=0
	   || ecc[2]!=0
	   || ecc[3]!=0
	   || ecc[4]!=0
          )
	  { printf("unable to clear ECC registers\n");
	    printf("control_reg#0 = %.4xH\n",ecc[0]);
	    printf("control_reg#1 = %.4xH\n",ecc[1]);
	    printf("control_reg#2 = %.4xH\n",ecc[2]);
	    printf("control_reg#4 = %.4xH\n",ecc[3]);
	    printf("control_reg#8 = %.4xH\n",ecc[4]);
	    goto exit;
	  }
	if(TP6X_ECC_ERR_DATA!=0)
	  { printf("ECC-error on ECC read #1\n");
	    goto exit;
	  }

//#define ECC0_DATA	0x1234
//#define ECC1_DATA	0x090c
//#define ECC2_DATA	0x0027
//#define ECC3_DATA	0x2cf6
//#define ECC4_DATA	0x00d9

#define ECC0_DATA	0x1234
#define ECC1_DATA	0x090c
#define ECC2_DATA	0x0027
#define ECC3_DATA	0x2cf6
#define ECC4_DATA	0x00d9


	TP6X_write_word(TP6X_ECC_AREA,TP6X_ECC_ECC+0x0, ECC0_DATA);
	TP6X_write_word(TP6X_ECC_AREA,TP6X_ECC_ECC+0x2, ECC1_DATA);
	TP6X_write_word(TP6X_ECC_AREA,TP6X_ECC_ECC+0x4, ECC2_DATA);
	TP6X_write_word(TP6X_ECC_AREA,TP6X_ECC_ECC+0x8, ECC3_DATA);
	TP6X_write_word(TP6X_ECC_AREA,TP6X_ECC_ECC+0x10,ECC4_DATA);
	if(TP6X_ECC_ERR_DATA!=0)
	  { printf("ECC-error on ECC write #1\n");
	    goto exit;
	  }

	ecc[0]= (TP6X_read_word(TP6X_ECC_AREA,TP6X_ECC_ECC+0x0 ))&~0xc0;
	ecc[1]= (TP6X_read_word(TP6X_ECC_AREA,TP6X_ECC_ECC+0x2 ))&~0xe0f0;
	ecc[2]= (TP6X_read_word(TP6X_ECC_AREA,TP6X_ECC_ECC+0x4 ))&~0xffc0;
	ecc[3]= (TP6X_read_word(TP6X_ECC_AREA,TP6X_ECC_ECC+0x8 ))&~0xc000;
	ecc[4]= (TP6X_read_word(TP6X_ECC_AREA,TP6X_ECC_ECC+0x10))&~0xff00;

	if(   ecc[0]!=ECC0_DATA
	   || ecc[1]!=ECC1_DATA
	   || ecc[2]!=ECC2_DATA
	   || ecc[3]!=ECC3_DATA
	   || ecc[4]!=ECC4_DATA
          )
	  { printf("verification error for writing randoms to ECC registers:\n");
	    printf("control_reg#0 = %.4xH    expected=%x\n",ecc[0],ECC0_DATA);
	    printf("control_reg#1 = %.4xH    expected=%x\n",ecc[1],ECC1_DATA);
	    printf("control_reg#2 = %.4xH    expected=%x\n",ecc[2],ECC2_DATA);
	    printf("control_reg#4 = %.4xH    expected=%x\n",ecc[3],ECC3_DATA);
	    printf("control_reg#8 = %.4xH    expected=%x\n",ecc[4],ECC4_DATA);
	    goto exit;
	  }
	if(TP6X_ECC_ERR_DATA!=0)
	  { printf("ECC-error on ECC read #1\n");
	    goto exit;
	  }

        for(i=0,x=0x0001;i<16;i++)
	{
		TP6X_write_word(TP6X_ECC_AREA,TP6X_ECC_ECC+(0x7 <<1),  x);
		TP6X_write_word(TP6X_ECC_AREA,TP6X_ECC_ECC+(0x9 <<1),  (x<<4 | x>>4));
		TP6X_write_word(TP6X_ECC_AREA,TP6X_ECC_ECC+(0x6 <<1), ~x);

		ecc[0]=TP6X_read_word(TP6X_ECC_AREA,TP6X_ECC_ECC+(0x7<<1));
		ecc[1]=TP6X_read_word(TP6X_ECC_AREA,TP6X_ECC_ECC+(0x6<<1));
		ecc[2]=TP6X_read_word(TP6X_ECC_AREA,TP6X_ECC_ECC+(0x9<<1));

		if(   ecc[0]!=x
		   || ecc[1]!=~x
		  )
		  { printf("verification error for circle-1 test to ECC registers:\n");
		    printf("control_reg#6 = %.4xH    expected=%x\n",ecc[0],x);
		    printf("control_reg#7 = %.4xH    expected=%x\n",ecc[1],~x);
		    printf("control_reg#9 = %.4xH    expected=%x\n",ecc[2],(x<<4 | x>>4));
		    goto exit;
		  }

             x = x<<1;

	}



	//---- disable ECC
	TP6X_SET_EMU_SEL_XEMU;
	if(TP6X_EMU_SEL_RG_DATA!=TP6X_EMU_SEL_XEMU)
	  { printf("cannot configure EMU to external emulator\n");
	    goto exit;
	  }

	if(TP6X_err_flag()) goto exit_err;
      }
	

   exit:
	TP6X_SET_EMU_SEL_XEMU;
	TP6X_SET_MRESET;
     ;

 }





