/**************************************************************************
   	HIF registerst test for TP62xx/TP67/TP64xx.
   	(C) MicroLAB Systems, 1998-2002

   	This utility performs test of host PCI interface registers 
   	of TOPRNADO-P6x board.

***************************************************************************/

#include <stdio.h>
#include <dos.h>
#include <stdlib.h>

#include <ips_ut.h>

#include "tp6x_h.h"

char err_mess[100];

#define BOARD_ID		0

int boards;
unsigned long _io0,_io1, _io3, _io4;
unsigned dev_id, index;
char _io0_name[40],_io1_name[40],_io3_name[40],_io4_name[40], dev_name[40];


main()
{ 
	int r,i;
   	unsigned x;
   	unsigned long ulx;
   	BYTE b;


   	printf("\nTORNADO-P6x Host I/F registers test. v2.0\n");
   	printf("(C) MicroLAB Systems, 1999-2002\n");
	
   	
	if(TP6X_open()!=TP6X_OK)
    {
exit_err:
		TP6X_last_err_message(err_mess);
        printf("err: %i  (%s)\n",TP6X_last_err(),err_mess);
		goto exit;
    }
   
	printf("boards installed: %i.  Selecting board #0...\n", TP6X_boards());

   	TP6X_sel_board_id(BOARD_ID);
   	TP6X_board_info(BOARD_ID,&dev_id,&index,NULL,NULL,&_io0,&_io1,NULL,&_io3,&_io4);
   	TP6X_dev_name(dev_name);
   	TP6X_area_alloc_name(TP6X_PCIC_AREA,_io0_name);
   	TP6X_area_alloc_name(TP6X_ECC_AREA, _io1_name);
   	TP6X_area_alloc_name(TP6X_DPM_AREA, _io3_name);
   	TP6X_area_alloc_name(TP6X_HIF_AREA, _io4_name);
   	if(TP6X_err_flag()) goto exit_err;

   	printf("TP6x device id = %x (%s)     index=%x\n",dev_id, dev_name, index);
   	printf("TP6x AMCC registers: %lxH (%s)\n",_io0,_io0_name);
   	printf("TP6x ECC area      : %lxH (%s)\n",_io1,_io1_name);
   	printf("TP6x DPRAM area    : %lxH (%s)\n",_io3,_io3_name);
   	printf("TP6x Host I/O area : %lxH (%s)\n",_io4,_io4_name);

   	printf("TP6x on-board DPRAM: %lxH\n",TP6X_dpram_len());
   	printf("TP6x on-board SRAM : %lxH\n",TP6X_sram_len());
   	printf("TP6x on-board SDRAM: %lxH\n",TP6X_dram_len());

    printf("\n");


	//================= SMP-0/1 test ==============
	// this test can be performed for TP62xx/TP67 boards only
	
	if(TP62XX_TP67_BOARD)
	{
		printf("testing SMP-0/1 ... 1-");
   		TP6X_SET_SMP_MODE_SPA;
   		TP6X_SET_SMP0_PAGE(0);
        TP6X_SET_SMP0_DPRAM_AREA;
   		TP6X_SET_SMP1_PAGE(5);
        TP6X_SET_SMP1_DPSEM_AREA;
		if(TP6X_err_flag()) goto exit_err;

		if(   	TP6X_SMP_MODE_DATA!=TP6X_SMP_MODE_SPA
	   		|| 	TP6X_SMP0_PAGE_DATA!=0
	   		|| 	TP6X_SMP0_AREA_DATA!=TP6X_SMP_DPRAM_AREA
	   		|| 	TP6X_SMP1_PAGE_DATA!=5
	   		|| 	TP6X_SMP1_AREA_DATA!=TP6X_SMP_DPSEM_AREA
          )
	    {  
test_err:
			printf("error\n");
	        goto exit_err;
	    }

        printf("2-");

        TP6X_SET_SMP0_DPSEM_AREA;
        TP6X_SET_SMP1_DPRAM_AREA;
   		TP6X_SET_SMP_MODE_DPA;
		for(i=0;i<=7;i++)
        {
   	    	TP6X_SET_SMP0_PAGE(i);
	    	if(TP6X_err_flag()) goto exit_err;

   	    	TP6X_SET_SMP1_PAGE(7-i);
	    	if(TP6X_err_flag()) goto exit_err;

	    	if(	  	TP6X_SMP0_PAGE_DATA!=i
	       		|| 	TP6X_SMP1_PAGE_DATA!=(7-i)
	       		|| 	TP6X_SMP0_AREA_DATA!=TP6X_SMP_DPSEM_AREA
	       		|| 	TP6X_SMP1_AREA_DATA!=TP6X_SMP_DPRAM_AREA
	       		|| 	TP6X_SMP_MODE_DATA!=TP6X_SMP_MODE_DPA
	      	  )
	        	goto test_err;
	    	if(TP6X_err_flag()) goto exit_err;
	  	}

        printf("3-");
        TP6X_SET_SMP0_RG(0);
        TP6X_SET_SMP1_RG(1);
        if(	  TP6X_SMP0_RG_DATA!=0
	       || TP6X_SMP0_RG_DATA!=0
	      )
			goto test_err;
        if(TP6X_err_flag()) goto exit_err;
		printf("... passed\n");
	}


	//================= CNTR register test ==============

	printf("testing CONTROL RG ...");
	for(i=0;i<=3;i++)
    {
   	    TP6X_SET_CNTR_RG(i);
	    if(TP6X_err_flag()) goto exit_err;

		if(	  (TP6X_CNTR_RG_DATA & 0x3) !=i
	      )
	        goto test_err;
	    if(TP6X_err_flag()) goto exit_err;
	}

	TP6X_SET_DSP_AMEN_ON;
	if(TP6X_err_flag()) goto exit_err;

	if((TP6X_DSP_AMEN_DATA)==0)  goto test_err;
	if(TP6X_err_flag()) goto exit_err;

   	TP6X_SET_DSP_AMEN_OFF;
	if(TP6X_err_flag()) goto exit_err;

	if((TP6X_DSP_AMEN_DATA)!=0) goto test_err;
	if(TP6X_err_flag()) goto exit_err;

	TP6X_SET_CNTR_RG(0);
	printf("... passed\n");


	//================= EMU selector test ==============
    printf("testing EMU SELECTOR ...");
    TP6X_SET_EMU_SEL_ECC;
    if( TP6X_EMU_SEL_RG_DATA!=TP6X_EMU_SEL_ECC) goto test_err;
    if(TP6X_err_flag()) goto exit_err;
    TP6X_SET_EMU_SEL_XEMU;
    if( TP6X_EMU_SEL_RG_DATA!=TP6X_EMU_SEL_XEMU) goto test_err;
    if(TP6X_err_flag()) goto exit_err;
	printf("... passed\n");


	//================= HM-RQ-0/1 register test ==============
	printf("testing HM_RQ-0/1 ...");
	for(i=0;i<=15;i++)
    {
   		TP6X_SET_HM_RQ0_RG(i);
	    if(TP6X_err_flag()) goto exit_err;

   	    TP6X_SET_HM_RQ1_RG(15-i);
	    if(TP6X_err_flag()) goto exit_err;

	    if(	   TP6X_HM_RQ0_RG_DATA !=i
	    	|| TP6X_HM_RQ1_RG_DATA !=(15-i)
	      )
	        goto test_err;
	    if(TP6X_err_flag()) goto exit_err;
	}
	printf("... passed\n");


	//================= IMR register test ==============
	printf("testing IMR ...");

   	TP6X_SET_IM_RG(0);
        if(TP6X_err_flag()) goto exit_err;
	if(TP6X_IM_RG_DATA !=0) goto test_err;
	if(TP6X_err_flag()) goto exit_err;

   	TP6X_SET_IM_RG(0xff);
    if(TP6X_err_flag()) goto exit_err;
	// Note no HPI_HINT_IE bit for TP6202/TP6203, 
	// no DPRAMIRQ_EN bit for TP64xx with DPRAM<256Kx32, 
	// and no DPRAM_ERR_IE for all TP64xx boards.
	if(TP6X_IM_RG_DATA != (TP6202_TP6203_BOARD? 0x35:
							(TP62_TP67_BOARD ? 0x37:
								(TP64XX_BOARD && TP6X_dpram_len()>0x80000)? 0x27:0x26)))
		goto test_err; 
	if(TP6X_err_flag()) goto exit_err;

	if(TP62XX_TP67_BOARD || (TP64XX_BOARD && TP6X_dpram_len()>0x80000))
	{
   		TP6X_SET_IM_RG(TP6X_IM_DPRAM_IE);
		if(TP6X_err_flag()) goto exit_err;
		if(TP6X_IM_RG_DATA !=TP6X_IM_DPRAM_IE) goto test_err;
		if(TP6X_err_flag()) goto exit_err;
	}

	if(TP62_TP67_BOARD || TP64XX_BOARD)
	{
	   	TP6X_SET_IM_RG(TP6X_IM_HPI_HINT_IE);
     	if(TP6X_err_flag()) goto exit_err;
		if(TP6X_IM_RG_DATA !=TP6X_IM_HPI_HINT_IE) goto test_err;
		if(TP6X_err_flag()) goto exit_err;
	 }

   	TP6X_SET_IM_RG(TP6X_IM_MH_RQ_IE);
	if(TP6X_err_flag()) goto exit_err;
	if(TP6X_IM_RG_DATA !=TP6X_IM_MH_RQ_IE) goto test_err;
	if(TP6X_err_flag()) goto exit_err;


	if(TP62XX_TP67_BOARD)
	{
   		TP6X_SET_IM_RG(TP6X_IM_DPRAM_ERR_IE);
        if(TP6X_err_flag()) goto exit_err;
		if(TP6X_IM_RG_DATA !=TP6X_IM_DPRAM_ERR_IE) goto test_err;
		if(TP6X_err_flag()) goto exit_err;
	}

   	TP6X_SET_IM_RG(TP6X_IM_HPI_ERR_IE);
    if(TP6X_err_flag()) goto exit_err;
	if(TP6X_IM_RG_DATA !=TP6X_IM_HPI_ERR_IE) goto test_err;
	if(TP6X_err_flag()) goto exit_err;

	printf("... passed\n");

	//================= DSP BMODE register test for TP64xx ==============
	if(TP64XX_BOARD)
	{
		printf("testing DSP BMODE ...");
		for(i=0;i<=3;i++)
    	{
   			TP6X_SET_DSP_BMODE_RG(i);
	    	if(TP6X_err_flag()) goto exit_err;

	    	if(TP6X_DSP_BMODE_RG_DATA!=i)  goto test_err;
	    	if(TP6X_err_flag()) goto exit_err;
		}

		TP6X_SET_DSP_BMODE_NONE;

		printf("... passed\n");
	}

	printf("No errors found.\n");

exit:
	TP6X_SET_CNTR_RG(0);
 }





