/************************************************************************************
   Host-to-DSP Communication Test for TP62xx/TP67/TP64xx. v.2.0
   (C) MicroLAB Systems, 1998-2002

   file: host PC monitor

   This utility performs test of communication between on0board DSP and host PCI 
   interface of TORNADO-P6x board. This PC executable runs with both TP62xx/TP67
   and TP64xx DSP kernels.

*************************************************************************************/

#include <stdio.h>
#include <string.h>
#include <dos.h>
#include <stdlib.h>

#include <ips_ut.h>
#include <mlu.h>

#include <tp6x_h.h>


BYTE err_mess[200];
unsigned long	START_SADDR = 0x400L,
                LAST_SADDR  = 0x7ffL;

unsigned long sa;
unsigned long *D,data,data_start, data_rd, *DPSEM;
unsigned smp_old; 
int ex_status,i;

MLU_TBDD TB;  // time bell descriptor


#define BOARD_ID	0

int boards,pass;
unsigned long _io0,_io1, _io3, _io4;
unsigned dev_id, index;
char _io0_name[40],_io1_name[40],_io3_name[40],_io4_name[40], dev_name[40];



#define CLEAR_CURRENT_LINE  printf("\r%79s\r"," ");


#define	DPRAM_SUBAREA_BADDR_ADDR	0x1fc	// DSP address of location for passing DPRAM sub-area base address

#define	MCD_ADDR					(0x200L)

#define	M_ID						0x110L
#define	PRG_ID						0x111L

#define	MCMND_NOP					0
#define	MCMND_SRAM_COMM				1
#define	MCMND_IRQ_DPRAM_COMM		2
#define	MCMND_IRQ_HM0_COMM			3
#define	MCMND_IRQ_HM1_COMM			4
#define	MCMND_IRQ_AOB_COMM			5
#define	MCMND_HPI_HINT_COMM			6
#define	MCMND_DPSEM_COMM			7
#define	MCMND_IRQ_RFIFO_COMM		8
#define	MCMND_IRQ_WFIFO_COMM		9

#define	MSTAT_SYNC					3
#define	MSTAT_BUSY					2
#define	MSTAT_ATTN					1
#define	MSTAT_RDY					0

#define	ERR_OK						0
#define	ERR_INV_CMND				-2
#define	ERR_INV_PARAM				-1


struct MCD_DD
{ 
	long  			m_id,
					prg_id,
					cmnd,
					status,
					error;

	unsigned long	up[4];
   	unsigned long   dpram_len;
};

struct MCD_DD *MCD;





char last_err_mess[100];
unsigned sn;

#define _PCIC_ADDON_TO_PCI_FIFO_EMPTY	((TP6X_PCIC_MCSR_DATA & 0x20L)==0x20L)
#define _PCIC_PCI_TO_ADDON_FIFO_EMPTY	((TP6X_PCIC_MCSR_DATA &  0x4L)==0x4L)
#define _PCIC_RESET_FIFO_FLAGS		(TP6X_SET_PCIC_MCSR(0x06000000L))
#define _PCIC_RESET_MBX_FLAGS		(TP6X_SET_PCIC_MCSR(0x08000000L))
#define _PCIC_RESET_FIFO_MBX_FLAGS	(TP6X_SET_PCIC_MCSR(0x0e000000L))



main()
{ 
	int r,i,ii;
   	unsigned long ld, _ul,il;


   	printf("\nTORNADO-P6x Test Utility for Host<-->DSP Communication. v.2.0\n");
   	printf("Copyright (C) MicroLAB Systems Ltd, 1996-2002\n\n");

   	if(TP6X_open()!=TP6X_OK)
    {
exit_err:
error:
		TP6X_last_err_message(last_err_mess);
	    printf("\n TP6X-error: %s\n",last_err_mess);
        printf(" appl-error: %s\n",err_mess);
		goto exit;
    }
   	printf("boards installed: %i.  Selecting board #0...\n", TP6X_boards());

   	TP6X_sel_board_id(BOARD_ID);
   	TP6X_board_info(BOARD_ID,&dev_id,&index,NULL,NULL,&_io0,&_io1,NULL,&_io3,&_io4);
   	TP6X_dev_name(dev_name);
   	TP6X_area_alloc_name(TP6X_PCIC_AREA,_io0_name);
   	TP6X_area_alloc_name(TP6X_ECC_AREA, _io1_name);
   	TP6X_area_alloc_name(TP6X_DPM_AREA, _io3_name);
   	TP6X_area_alloc_name(TP6X_HIF_AREA, _io4_name);
   	if(TP6X_err_flag()) goto exit_err;

   	printf("TP6x device id = %x (%s)     index=%x\n",dev_id, dev_name, index);
   	printf("TP6x AMCC registers: %lxH (%s)\n",_io0,_io0_name);
   	printf("TP6x ECC area      : %lxH (%s)\n",_io1,_io1_name);
   	printf("TP6x DPRAM area    : %lxH (%s)\n",_io3,_io3_name);
   	printf("TP6x Host I/O area : %lxH (%s)\n",_io4,_io4_name);
   	printf("TP6x on-board DPRAM: %lxH\n",TP6X_dpram_len());
   	printf("TP6x on-board SRAM : %lxH\n",TP6X_sram_len());
   	printf("TP6x on-board SDRAM: %lxH\n",TP6X_dram_len());
   	printf("\n");

   	*err_mess=0;

	if(TP62XX_TP67_BOARD)
	{
   		smp_old=TP6X_SMP0_RG_DATA;
   		TP6X_SET_SMP_MODE_DPA;
   		TP6X_CLR_DPRAM_ERR;
	}

   	TP6X_SET_MRESET;
   	TP6X_SET_MRESET_MODE_HOST;
   	TP6X_SET_DSP_AMEN_OFF;
   	TP6X_SET_IM_RG(0);
   	TP6X_SET_PCIC_INTCSR(0);
   	_PCIC_RESET_FIFO_FLAGS;
   	_PCIC_RESET_MBX_FLAGS;

   	if(TP6X_err_flag()) goto error;

	// for TP62xx/TP67, use SMP1 for DPSEM access
	if(TP62XX_TP67_BOARD)
	{
   		TP6X_set_smp_ptr(0L,TP6X_SMP_DPSEM_AREA,TP6X_SMP_SMP1_SEL,&DPSEM);
   		for(i=0;i<8;i++) DPSEM[i]=1;	// clear DPSEMs
	}

	// for TP64xx boards, select no DSP boot
	if(TP64XX_BOARD)
	{
		TP6X_SET_DSP_BMODE_NONE;
	}

   	TP6X_set_smp_ptr(MCD_ADDR,TP6X_SMP_DPRAM_AREA,TP6X_SMP_SMP0_SEL,&MCD);

   	if(TP6X_err_flag()) goto exit_err;

	//-------------------- initialization ------------------------
   	printf("testing DSP initialization ... ");

   	MCD->m_id=-1L;
   	MCD->prg_id=-1L;
   	MCD->cmnd=-1L;
   	MCD->status=-1L;
   	MCD->error=-1L;
   	MCD->up[0]=0xffffffffL;
   	MCD->up[1]=0xffffffffL;

		// for TP64xx boards, do not pass DPRAM length, since DPRAM IRQ is not
		// available for PC DOS utilties
   	MCD->dpram_len= (TP62XX_TP67_BOARD)? TP6X_DPM_DPRAM_LEN:0L;

   	if(TP62XX_TP67_BOARD && TP6X_DPRAM_ERR_DATA!=0)
	{
		strcpy(err_mess,"DPRAM error on init comm");
	    goto error;
	}


	// release DSP reset and initialize HPI
   	TP6X_SET_MGO;
   	TP6X_HPI_INIT;	

	if(TP64XX_BOARD)
	{
		// for TP64xx boards, we must pass base address of DPRAM sub-area in
		// DSP address space via location @DPRAM_SUBAREA_BADDR_ADDR in DSP memory.
		// DSP s/w will initially clear this location and then poll it for !=0 value.
		// We can write to this location after some pause.

		// wait sometime in order to ensure that DSP has cleared this location
		for(il=0L;il<50000L;il++);

		// now write to this location
		TP6X_SET_HPIA(DPRAM_SUBAREA_BADDR_ADDR);
		TP6X_SET_HPID(TP6X_dpram_area_dsp_baddr()+MCD_ADDR);

		if(TP6X_HPI_ERR_DATA!=0)
   		{
       		strcpy(err_mess,"HPI error is set at passing base address for DPRAM");
       		goto error;
   		}
	}

	// now set time control =1s and wait for DSP will init or timeout
   	MLU_set_bell(1,&TB);  
   	while (MCD->status!=MSTAT_RDY) 
	{
    	if(MLU_check_bell(&TB)<0)
	   	{ 
no_reply:
			strcpy(err_mess,"no reply from TP6X");
	       	goto error;
	   	}
	
		if(TP62XX_TP67_BOARD && TP6X_DPRAM_ERR_DATA!=0)
		{ 
dpram_error:
			printf(err_mess, "error: DPRAM error");
			goto error;
		}
    }


	// validate returned MCD
	if(		MCD->m_id!=M_ID      
		||	MCD->prg_id!=PRG_ID  
		||	MCD->cmnd!=MCMND_NOP      
		||	MCD->status!=MSTAT_RDY    
		||	MCD->error !=ERR_OK       
		||	MCD->up[0] !=0x98765432L      
		||	MCD->up[1] !=0xabcdef01L
      )
	{ 
		strcpy(err_mess,"invalid TP6X initialization");
	    goto error;
	}

   	if(TP62XX_TP67_BOARD && TP6X_DPRAM_ERR_DATA!=0)	goto dpram_error;
   	if(TP6X_err_flag()) goto error;




//---------- communication via DPRAM ----------------------------
   printf("passed\ntesting communication via DPRAM ... ");

   MCD->cmnd=MCMND_SRAM_COMM;
   MCD->error=-1L;
   MCD->up[0]=0xffffffffL;
   MCD->up[1]=0xffffffffL;
   MCD->up[2]=0xffffffffL;
   MCD->up[3]=0xffffffffL;
   MCD->status=MSTAT_ATTN;

   MLU_set_bell(1,&TB);  // set time control =1s

   while (MCD->status!=MSTAT_RDY)
     {
       if(MLU_check_bell(&TB)<0) goto no_reply;
       if(TP62XX_TP67_BOARD && TP6X_DPRAM_ERR_DATA!=0)	goto dpram_error;
     }

   if(MCD->error !=ERR_OK       ||
      MCD->up[0] !=0xfedc0000L       ||
      MCD->up[1] !=0xba98L       ||
      MCD->up[2] !=0x76540000L       ||
      MCD->up[3] !=0x3210L
     )
	   { inv_cmnd_exec_result:
               strcpy(err_mess,"invalid command execution result");
	       goto error;
	   }
   if(TP6X_err_flag()) goto error;



//---------------- HM_RQ/MH_RQ test ----------------------------
   printf("passed\ntesting communication via HM_RQ/MH_RQ ... ");

   if( TP6X_CLR_MH_RQ!=0  || TP6X_MH_RQ_DATA!=0 )
      {
        strcpy(err_mess,"cannot clear MH_RQ prior -0");
        goto error;
      }

	//--- initially testing for HM_RQ-0
   MCD->cmnd=MCMND_IRQ_HM0_COMM;
   MCD->error=-1L;
   MCD->up[0]=0xffffffffL;
   MCD->up[1]=0xffffffffL;
   MCD->up[2]=0xffffffffL;
   MCD->up[3]=0xffffffffL;
   MCD->status=MSTAT_ATTN;

   if(TP6X_DPRAM_ERR_DATA!=0)	goto dpram_error;
   MLU_set_bell(1,&TB);  // set time control =1s

   if(   TP6X_SET_HM_RQ0_RG(3)!=TP6X_OK
      || TP6X_HM_RQ0_RG_DATA !=3
     )
      { strcpy(err_mess,"cannot set HM_RQ-0 ");
	goto error;
      }

   while (TP6X_MH_RQ_DATA==0)
     {
       if(MLU_check_bell(&TB)<0) goto no_reply;
     }

   if(   MCD->error !=ERR_OK       	
      || MCD->up[0] !=0x76543210L
      || MCD->up[1] !=0xfedcba98L
      || MCD->up[2] !=3L 		
      || MCD->up[3] !=0xcL
      || TP6X_HM_RQ0_RG_DATA !=0
     )
	goto  inv_cmnd_exec_result;

   if( TP6X_CLR_MH_RQ!=0  || TP6X_MH_RQ_DATA!=0 )
      {
               strcpy(err_mess,"cannot clear MH_RQ after -0");
	       goto error;
      }
   if(TP62XX_TP67_BOARD && TP6X_DPRAM_ERR_DATA!=0)	goto dpram_error;
   if(TP6X_err_flag()) goto error;


		//--- now testing for HM-RQ-1
   MCD->status=MSTAT_SYNC; //-- this is switching to HM_RQ-1 detection

   MCD->cmnd=MCMND_IRQ_HM1_COMM;
   MCD->error=-1L;
   MCD->up[0]=0xffffffffL;
   MCD->up[1]=0xffffffffL;
   MCD->up[2]=0xffffffffL;
   MCD->up[3]=0xffffffffL;

   if(TP62XX_TP67_BOARD && TP6X_DPRAM_ERR_DATA!=0)	goto dpram_error;
   MLU_set_bell(1,&TB);  // set time control =1s

   if(   TP6X_SET_HM_RQ1_RG(5)!=TP6X_OK
      || TP6X_HM_RQ1_RG_DATA !=5
     )
      {
               strcpy(err_mess,"cannot set HM_RQ-1 ");
	       goto error;
      }

   while (TP6X_MH_RQ_DATA==0)
     {
       if(MLU_check_bell(&TB)<0) goto no_reply;
     }

   if(	   MCD->error !=ERR_OK
       ||  MCD->up[1] !=0x76543210L
       ||  MCD->up[0] !=0xfedcba98L
       ||  MCD->up[2] !=0xaL 		
       ||  MCD->up[3] !=0x5L
       || TP6X_HM_RQ1_RG_DATA !=0
     )
	goto  inv_cmnd_exec_result;

   if( TP6X_CLR_MH_RQ!=0  || TP6X_MH_RQ_DATA!=0 )
      {
               strcpy(err_mess,"cannot clear MH_RQ after -1");
	       goto error;
      }
   if(TP62XX_TP67_BOARD && TP6X_DPRAM_ERR_DATA!=0)	goto dpram_error;
   if(TP6X_err_flag()) goto error;



//----------- testing HPI/HINT communication -----------------
	//-- for TP62/TP67/TP64xx test for DSPINT/HINT
	//   for TP6202/TP6203: test for DSPINT only

   printf("passed\ntesting HPI/DSPINT%s ... ",(TP62_TP67_BOARD || TP64XX_BOARD)? "-HINT":"");

   if(TP6X_HPI_ERR_DATA)
   {
       strcpy(err_mess,"HPI error is not initially clear");
       goto error;
   }

   if((TP62_TP67_BOARD || TP64XX_BOARD) && TP6X_HPI_HINT_DATA!=0)
      {
           strcpy(err_mess,"HPI/HINT is not initially CLEAR");
	       goto error;
      }

   if(TP6X_HPI_DSPINT_DATA!=0)
      {
               strcpy(err_mess,"HPI/DSPINT is not initially CLEAR");
	       goto error;
      }

   TP6X_SET_HPI_DSPINT;

   if(TP6X_HPI_ERR_DATA)
   {
	_hpi_error:
       strcpy(err_mess,"\nHPI error has been detected");
       goto error;
   }

   if(TP6X_HPI_DSPINT_DATA==0)
      {
           strcpy(err_mess,"cannot set HPI/DSPINT");
	       goto error;
      }

   MCD->up[0]=0xffffffffL;
   MCD->up[1]=0xffffffffL;
   MCD->up[2]=0xffffffffL;
   MCD->up[3]=0xffffffffL;

   MCD->cmnd=MCMND_HPI_HINT_COMM;
   MCD->error=-1L;
   MCD->status=MSTAT_ATTN;

   MLU_set_bell(1,&TB);
   while (MCD->status!=MSTAT_RDY)
     {
       if(MLU_check_bell(&TB)<0) goto no_reply;
       if(TP62XX_TP67_BOARD && TP6X_DPRAM_ERR_DATA!=0)	goto dpram_error;
     }

   if(	   MCD->error !=ERR_OK
       ||  MCD->up[0] != 0x77221144 
       ||  MCD->up[1] != ~MCD->up[0]
       ||  MCD->up[2] != 0x90785634
       ||  MCD->up[3] != 0x21436587
     )
	goto  inv_cmnd_exec_result;


   if(TP6X_HPI_DSPINT_DATA!=0 )
      {
               strcpy(err_mess,"HPI/DSPINT has not been cleared by DSP");
	       goto error;
      }


   if((TP62_TP67_BOARD || TP64XX_BOARD) &&  TP6X_HPI_HINT_DATA!=TP6X_IS_HPI_HINT_IRQ )
      {
               strcpy(err_mess,"HPI/HINT is missed");
	       goto error;
      }

   if(TP62_TP67_BOARD || TP64XX_BOARD)
	{ TP6X_CLR_HPIC_HINT;
	  if(TP6X_HPIC_HINT_DATA!=0)
      		{
	               strcpy(err_mess,"cannot clear HPI/HINT /after");
		       goto error;
      		}
	}

   if(TP6X_err_flag()) goto error;

   if(TP6X_HPI_ERR_DATA)
	goto _hpi_error;


//---------------- NMI test via IMBX-0 ----------------------------

 nmi_test: 

   printf("passed\ntesting communication via NMI-AOB/IMBX/OMBX ... ");

   MCD->cmnd=MCMND_IRQ_AOB_COMM;
   MCD->error=-1L;
   MCD->up[0]=0xffffffffL;
   MCD->up[1]=0xffffffffL;
   MCD->up[2]=0xffffffffL;

   if(TP6X_DPRAM_ERR_DATA!=0)	goto dpram_error;
   MLU_set_bell(1,&TB);  // set time control =1s

   _PCIC_RESET_MBX_FLAGS;	// clear IMBX-0 ready flag (if set)

   if(   TP6X_SET_PCIC_OMBX(0,0x75319bdfL)!=TP6X_OK
      || TP6X_PCIC_OMBX_DATA(0) !=0x75319bdfL
     )
      {
               strcpy(err_mess,"cannot set OMBX-0 pass#1");
	       goto error;
      }

   while (MCD->error!=ERR_OK)
     {
       if(MLU_check_bell(&TB)<0) goto no_reply;
     }

   if(	 MCD->error !=ERR_OK       	
      || MCD->up[0] !=0x01234567L
      || MCD->up[1] !=0x89abcdefL       		
      || MCD->up[2] !=0x75319bdfL 		      	
      || (TP6X_PCIC_MBEF_DATA & 0x80000L)==0	
      || TP6X_PCIC_IMBX_DATA(0)!=~0x75319bdfL
      || (TP6X_PCIC_MBEF_DATA & 0x80000L)!=0	
     )
	goto  inv_cmnd_exec_result;

   if(TP62XX_TP67_BOARD && TP6X_DPRAM_ERR_DATA!=0)	goto dpram_error;
   if(TP6X_err_flag()) goto error;

	// now repeat with different data
   MCD->error=-1L;
   MCD->up[0]=0xffffffffL;
   MCD->up[1]=0xffffffffL;
   MCD->up[2]=0xffffffffL;

   if(TP62XX_TP67_BOARD && TP6X_DPRAM_ERR_DATA!=0)	goto dpram_error;
   MLU_set_bell(1,&TB);  // set time control =1s

   if(   TP6X_SET_PCIC_OMBX(0,0x5555aaaaL)!=TP6X_OK
      || TP6X_PCIC_OMBX_DATA(0) !=0x5555aaaaL
     )
      {
               strcpy(err_mess,"cannot set OMBX-0 pass#2");
	       goto error;
      }

   while (MCD->error!=ERR_OK)
     {
       if(MLU_check_bell(&TB)<0) goto no_reply;
     }

   if(	 MCD->error !=ERR_OK       	
      || MCD->up[0] !=0x01234567L
      || MCD->up[1] !=0x89abcdefL       		
      || MCD->up[2] !=0x5555aaaaL 		      	
      || (TP6X_PCIC_MBEF_DATA & 0x80000L)==0	
      || TP6X_PCIC_IMBX_DATA(0)!=~0x5555aaaaL
      || (TP6X_PCIC_MBEF_DATA & 0x80000L)!=0	
     )
	goto  inv_cmnd_exec_result;

   if(TP62XX_TP67_BOARD && TP6X_DPRAM_ERR_DATA!=0)	goto dpram_error;
   if(TP6X_err_flag()) goto error;


//---------------- MIRQ3 test via DPRAM-IRQ ----------------------------
	// this test runs with TP62xx/TP67 boards only, since
	// DPRAM IRQs locations are not accessable for TP6x PC DOS 
	// utilities with TP64xx boards 
	if(TP62XX_TP67_BOARD)
	{
   		printf("passed\ntesting communication via DPRAM-IRQ/PCI_IRQ... ");

   		MCD->cmnd=MCMND_IRQ_DPRAM_COMM;
   		MCD->error=-1L;
   		MCD->up[0]=0xffffffffL;
   		MCD->up[1]=0xffffffffL;
   		MCD->up[2]=0xffffffffL;
   		MCD->up[3]=0xffffffffL;

   		ld=TP6X_DPRAM_MH_RQ_DATA;	// clear DPRAM_MH_RQ
   		TP6X_SET_DPRAM_MH_RQ(0);

   		if((TP6X_PCIC_INTCSR_DATA & 0x800000L)!=0) // test for PCIC IRQ is valid
     	{ 
			TP6X_SET_PCIC_INTCSR(TP6X_PCIC_INTCSR_DATA & 0x3f0000L);
       		if((TP6X_PCIC_INTCSR_DATA & 0x800000L)!=0) // check again
	 		{
            	strcpy(err_mess,"cannot clear old PCIC IRQ");
	       		goto error;
	 		}
     	}

   		if(   	TP6X_SET_PCIC_INTCSR(0x1f00L)!=0
      		|| 	(TP6X_PCIC_INTCSR_DATA & 0xffff)!=0x1f00L
      		|| 	TP6X_SET_IM_RG(1)!=0
      		|| 	TP6X_IM_RG_DATA!=1
     	  )	
      	{
        	strcpy(err_mess,"cannot configure PCIC IRQ on EMBCLK ");
	       	goto error;
      	}

   		if(TP62XX_TP67_BOARD && TP6X_DPRAM_ERR_DATA!=0)	goto dpram_error;
   		MLU_set_bell(1,&TB);  // set time control =1s

   		if(   	TP6X_SET_DPRAM_HM_RQ(0x12487d3cL)!=TP6X_OK
      		|| 	TP6X_DPRAM_HM_RQ_DATA  !=0x12487d3cL
     	  )
      	{
        	strcpy(err_mess,"cannot set DPRAM HM_RQ ");
	       	goto error;
      	}

   		while (MCD->error!=ERR_OK)
     	{
       		if(MLU_check_bell(&TB)<0) goto no_reply;
     	}

   		if(	 	MCD->error !=ERR_OK       	
      		|| 	MCD->up[0] !=0x01230000L
      		|| 	MCD->up[1] !=0x4567L       		
      		|| 	MCD->up[2] !=0x89ab0000L 		      	
      		|| 	MCD->up[3] !=0xcdefL 		      	
      		|| 	TP6X_DPRAM_IRQ_DATA==0	
      		|| 	TP6X_DPRAM_MH_RQ_DATA!=~0x12487d3cL
      		|| 	(TP6X_PCIC_INTCSR_DATA & 0x800000L)==0
     	  )
			goto  inv_cmnd_exec_result;

   		if((TP6X_PCIC_INTCSR_DATA & 0x800000L)!=0) // test for PCIC IRQ is valid
     	{ 
			TP6X_SET_PCIC_INTCSR(TP6X_PCIC_INTCSR_DATA & 0x3f0000L);
       		if((TP6X_PCIC_INTCSR_DATA & 0x800000L)!=0) // check again
	 		{
            	strcpy(err_mess,"cannot clear PCIC IRQ on exit");
	       		goto error;
	 		}
     	}

   		if(   	TP6X_SET_PCIC_INTCSR(0)!=TP6X_OK
      		|| 	(TP6X_PCIC_INTCSR_DATA & 0xffff)!=0L
      		|| 	TP6X_SET_IM_RG(0)!=0
      		|| 	TP6X_IM_RG_DATA!=0
     	  )	
      	{
        	strcpy(err_mess,"cannot clear PCIC IRQ on EMBCLK ");
	       	goto error;
      	}

   		if(TP62XX_TP67_BOARD && TP6X_DPRAM_ERR_DATA!=0)	goto dpram_error;
   		if(TP6X_err_flag()) goto error;
	}



//---------------- RFIFO/WFIFO test with IRQs via RFIFO -----------
   printf("passed\ntesting communication via RFIFO IRQ ... ");

   MCD->cmnd=MCMND_IRQ_RFIFO_COMM;
   MCD->error=-1L;
   MCD->up[0]=0xffffffffL;
   MCD->up[1]=0xffffffffL;
   MCD->up[2]=0xffffffffL;
   MCD->up[3]=0xffffffffL;

   if(TP62XX_TP67_BOARD && TP6X_DPRAM_ERR_DATA!=0)	goto dpram_error;
   MLU_set_bell(1,&TB);  // set time control =1s

   if(   !_PCIC_ADDON_TO_PCI_FIFO_EMPTY
      || !_PCIC_PCI_TO_ADDON_FIFO_EMPTY
     )
      {
        strcpy(err_mess,"FIFO is not empty");
	goto error;
      }


   if(   TP6X_SET_PCIC_INTCSR(0x0c000000L)!=TP6X_OK
      || TP6X_PCIC_INTCSR_DATA!=0x0c000000L
     )
      {
               strcpy(err_mess,"cannot configure FIFO advance control ");
	       goto error;
      }


   if( TP6X_SET_PCIC_FIFO(0xccccddddL)!=TP6X_OK)
      {
               strcpy(err_mess,"cannot write to PCIC FIFO ");
	       goto error;
      }
   while (MCD->error!=ERR_OK)
     {
       if(MLU_check_bell(&TB)<0) goto no_reply;
     }

   if(	 MCD->error !=ERR_OK       	
      || MCD->up[0] !=0x55555555L
      || MCD->up[1] !=0xaaaaaaaaL       		
      || MCD->up[2] !=0xccccddddL 		      	
      || MCD->up[3] !=0L 		      	
      || _PCIC_ADDON_TO_PCI_FIFO_EMPTY	
      || TP6X_PCIC_FIFO_DATA!=~0xccccddddL
      || !_PCIC_ADDON_TO_PCI_FIFO_EMPTY	
      || !_PCIC_PCI_TO_ADDON_FIFO_EMPTY	
     )
	goto  inv_cmnd_exec_result;

   if(TP62XX_TP67_BOARD && TP6X_DPRAM_ERR_DATA!=0)	goto dpram_error;
   if(TP6X_err_flag()) goto error;

              //--- repeat with new FIFO data
   MCD->cmnd=MCMND_IRQ_RFIFO_COMM;
   MCD->error=-1L;
   MCD->up[0]=0xffffffffL;
   MCD->up[1]=0xffffffffL;
   MCD->up[2]=0xffffffffL;
   MCD->up[3]=0xffffffffL;

   if(TP62XX_TP67_BOARD && TP6X_DPRAM_ERR_DATA!=0)	goto dpram_error;
   MLU_set_bell(1,&TB);  // set time control =1s

   if( TP6X_SET_PCIC_FIFO(0x99887766L)!=TP6X_OK)
      {
               strcpy(err_mess,"cannot write to PCIC FIFO ");
	       goto error;
      }
   while (MCD->error!=ERR_OK)
     {
       if(MLU_check_bell(&TB)<0) goto no_reply;
     }

   if(	 MCD->error !=ERR_OK       	
      || MCD->up[0] !=0x55555555L
      || MCD->up[1] !=0xaaaaaaaaL       		
      || MCD->up[2] !=0x99887766L 		      	
      || MCD->up[3] !=1L 		      	
      || _PCIC_ADDON_TO_PCI_FIFO_EMPTY	
      || TP6X_PCIC_FIFO_DATA!=~0x99887766L
      || !_PCIC_ADDON_TO_PCI_FIFO_EMPTY	
      || !_PCIC_PCI_TO_ADDON_FIFO_EMPTY	
     )
	goto  inv_cmnd_exec_result;

   if(TP62XX_TP67_BOARD && TP6X_DPRAM_ERR_DATA!=0)	goto dpram_error;
   if(TP6X_err_flag()) goto error;


//---------------- WFIFO test with IRQs via WFIFO -----------
   printf("passed\ntesting communication via WFIFO IRQ ... ");

   MCD->cmnd=MCMND_IRQ_WFIFO_COMM;
   MCD->error=-1L;
   MCD->up[0]=0xffffffffL;
   MCD->up[1]=0xffffffffL;
   MCD->up[2]=0xffffffffL;
   MCD->up[3]=0xffffffffL;
   MCD->status=MSTAT_ATTN;

   if(TP62XX_TP67_BOARD && TP6X_DPRAM_ERR_DATA!=0)	goto dpram_error;
   MLU_set_bell(1,&TB);  // set time control =1s

   while (MCD->error!=ERR_OK)
     {
       if(MLU_check_bell(&TB)<0) goto no_reply;
     }

   if(	 MCD->error !=ERR_OK       	
      || MCD->up[0] !=0xaaaaaaaaL
      || MCD->up[1] !=0x55555555L       		
      || MCD->up[3] ==0L 		      	
      || MCD->up[3] >8L 		      	
      || _PCIC_ADDON_TO_PCI_FIFO_EMPTY	
	  || TP6X_PCIC_FIFO_DATA!=0xcdef0000L
      || TP6X_PCIC_FIFO_DATA!=0xcdef0001L
      || TP6X_PCIC_FIFO_DATA!=0xcdef0002L
      || TP6X_PCIC_FIFO_DATA!=0xcdef0003L
      || TP6X_PCIC_FIFO_DATA!=0xcdef0004L
      || TP6X_PCIC_FIFO_DATA!=0xcdef0005L
      || TP6X_PCIC_FIFO_DATA!=0xcdef0006L
      || TP6X_PCIC_FIFO_DATA!=0xcdef0007L
     )
	goto  inv_cmnd_exec_result;


   MCD->status=MSTAT_SYNC;
   if(TP62XX_TP67_BOARD && TP6X_DPRAM_ERR_DATA!=0)	goto dpram_error;
   MLU_set_bell(1,&TB);  // set time control =1s

   while (MCD->status!=MSTAT_RDY)
     {
       if(MLU_check_bell(&TB)<0) goto no_reply;
     }

		// perform max 8 reads after WFIFO has been disabled
		// and check for WFIFO is now empty
   for(i=0;i<8;i++)
    {
      if(!_PCIC_ADDON_TO_PCI_FIFO_EMPTY) 
        { ld=TP6X_PCIC_FIFO_DATA;
        }
       else
	  break;
    }

   if( !_PCIC_ADDON_TO_PCI_FIFO_EMPTY	)
	goto  inv_cmnd_exec_result;

   if(TP62XX_TP67_BOARD && TP6X_DPRAM_ERR_DATA!=0)	goto dpram_error;
   if(TP6X_err_flag()) goto error;


	//---------------- DPSEM test (TP62xx/TP67 only) -----------
	if(TP62XX_TP67_BOARD)
	{
   		printf("passed\ntesting communication via DPSEM ... ");

  		for(i=0;i<8;i++)	// repeat test for all semaphores
  		{
   			MCD->cmnd=MCMND_DPSEM_COMM;
   			MCD->error=-1L;
   			MCD->up[0]=0xffffffffL;
   			MCD->up[1]=0xffffffffL;
   			MCD->up[2]=0xffffffffL;
   			MCD->up[3]=(long)i;
   			MCD->status=MSTAT_ATTN;
		

   			if(TP6X_DPRAM_ERR_DATA!=0)	goto dpram_error;
   			MLU_set_bell(1,&TB);        // set time control =1s
   			while (MCD->up[0]!=0x0740L)	// wait for DSP will enter the test dialog
     		{
       			if(MLU_check_bell(&TB)<0) goto no_reply;
     		}

   			//--test semaphore fm host
   			DPSEM[i]=1;
   			if((DPSEM[i]&0x1)!=1) goto inv_cmnd_exec_result;
   			DPSEM[i]=0;
   			if((DPSEM[i]&0x1)!=0) goto inv_cmnd_exec_result;

        	// now allow DSP to set semaphore and ensure failure doing this
   			MCD->up[0]=0x0741L;
   			MLU_set_bell(1,&TB);        // set time control =1s
   			while (MCD->up[0]!=0x0742L)	// wait for DSP will enter the test dialog
     		{
       			if(MLU_check_bell(&TB)<0) goto no_reply;
     		}

   			DPSEM[i]=1;
   			if((DPSEM[i]&0x1)!=1) goto inv_cmnd_exec_result;

        	// now allow DSP to set semaphore and ensure OK
   			MCD->up[0]=0x0743L;
   			MLU_set_bell(1,&TB);        // set time control =1s

   			while (MCD->status!=MSTAT_RDY)
   			// wait for DSP will finish test
     		{
       			if(MLU_check_bell(&TB)<0) goto no_reply;
     		}

   			if(	 	MCD->error !=ERR_OK
      			|| 	MCD->up[0]!=0x0744L
      			|| 	(DPSEM[i]&0x1)!=1
     	  	  )
       			goto inv_cmnd_exec_result;

   			DPSEM[i]=0;
   			if((DPSEM[i]&0x1)!=0) goto inv_cmnd_exec_result;
   			DPSEM[i]=1;
   			if((DPSEM[i]&0x1)!=1) goto inv_cmnd_exec_result;

   			if(TP6X_DPRAM_ERR_DATA!=0)	goto dpram_error;
   			if(TP6X_err_flag()) goto error;
  		}
	}



//------------- the end --------------------
   	printf("passed\n\n");


exit:
	TP6X_SET_MRESET;
	if(TP62XX_TP67_BOARD) 
	{
        TP6X_SET_SMP0_RG(smp_old);
		TP6X_CLR_DPRAM_ERR;
	   	TP6X_SET_SMP_MODE_SPA;
	}
   	TP6X_SET_MRESET_MODE_HOST;
   	TP6X_SET_DSP_AMEN_OFF;
   	TP6X_HPI_INIT;
}





