;**************************************************************************
; 32-bit IN/OUT code for x86 (real-mode for DOS, Windows 95/98)
; Copyright (C) MicroLAB Systems, 1997-2000
;
; note:
;   This code must be compiled with MASM v.5.x or v.6.x
;**************************************************************************

                .MODEL small
		.386
		.code
                 

   public __inport32, __outport32


;================= 32-bit I/O port INPUT ==================================
; C-synopsis:
;   void _inport32(unsigned port_address, unsigned long *port_data)
;

__inport32  proc   far

        push bp
        mov bp,sp
        pushf     
        push ds
        push di
        push dx
        push cx
        push eax

        mov dx,word ptr [bp+6]    ; get I/O port address
        mov di,word ptr [bp+8]    ; get segment/offset of data pointer to 32-bit data word
	mov cx,word ptr [bp+10]
	mov ds,cx		  ; load pointer segment to DS 

	in eax,dx		  ; perform 32-bit data INPUT

	mov dword ptr ds:[di],eax ; save read data at the pointer

	pop eax
        pop cx
	pop dx
        pop di
        pop ds
        popf
        pop bp
        ret

__inport32   endp

;=======================================================================


;================= 32-bit I/O port OUTPUT ==============================
; C-synopsis:
;   void _outport32(unsigned port_address, unsigned long port_data)
;

__outport32  proc   far

        push bp
        mov bp,sp
        pushf     
        push dx
        push bx
        push cx
        push eax

        mov dx,word ptr [bp+6]    ; get I/O port address
        mov bx,word ptr [bp+8]    ; get MSW of 32-bit output data
	mov cx,word ptr [bp+10]	  ; get LSW of 32-bit output data
	push cx			  ; move [BX:CX] to EAX via PUSH/POP
	push bx
	pop  eax

	out dx,eax		  ; perform 32-bit data OUTPUT

	pop eax
        pop cx
	pop bx
        pop dx
        popf
        pop bp
        ret

__outport32   endp

;=======================================================================

         end


