/*******************************************************************
   PCI BIOS I/F Library.    v.1.1
   (C) MicroLAB Systems Ltd, 1998-1999

   file: HEADER (.H)
*******************************************************************/

//------------------------ Error Codes -----------------------

#define	_PCI_NO_ERR			0
#define	_PCI_BIOS_NOT_FOUND_ERR		-3001
#define	_PCI_DEV_NOT_FOUND_ERR		-3002
#define	_PCI_CNF_RG_READ_ERR		-3003
#define	_PCI_INV_PARAM_ERR		-3010
#define	_PCI_BIOS_INV_FUNCTION_ERR	(-3000-0x81)
#define	_PCI_BIOS_INV_VENDOR_ID_ERR	(-3000-0x83)
#define	_PCI_BIOS_INV_DEV_ID_ERR	(-3000-0x86)
#define	_PCI_BIOS_INV_RG_NUMBER_ERR	(-3000-0x87)

typedef unsigned char BYTE;


//--------- PCI Configuration Space Registers ----------------

#define _PCI_VENDOR_ID_CNF_RG		0x00
#define _PCI_DEV_ID_CNF_RG		0x02
#define _PCI_COMMAND_CNF_RG		0x04
#define _PCI_STATUS_CNF_RG		0x06
#define _PCI_REV_ID_CNF_RG		0x08
#define _PCI_CLASS_CODE_CNF_RG		0x09
#define _PCI_CACHE_LINE_SIZE_CNF_RG	0x0c
#define _PCI_MASTER_LATENCY_CNF_RG	0x0d
#define _PCI_HEADER_TYPE_CNF_RG		0x0e
#define _PCI_BIST_CNF_RG		0x0f
#define _PCI_BADDR0_CNF_RG		0x10
#define _PCI_BADDR1_CNF_RG		0x14
#define _PCI_BADDR2_CNF_RG		0x18
#define _PCI_BADDR3_CNF_RG		0x1c
#define _PCI_BADDR4_CNF_RG		0x20
#define _PCI_BADDR5_CNF_RG		0x24
#define _PCI_EXP_ROM_CNF_RG		0x30
#define _PCI_INT_LINE_CNF_RG		0x3c
#define _PCI_INT_PIN_CNF_RG		0x3d
#define _PCI_MIN_GNT_CNF_RG		0x3e
#define _PCI_MAX_LAT_CNF_RG		0x3f



//--------------- function declarations --------------------
int _PCI_open			(BYTE *last_pci_bus_number);
int _PCI_find_device		(unsigned vendor_id, unsigned dev_id,unsigned index,BYTE *bus, BYTE *dev_and_function );
int _PCI_read_cnf_byte		(BYTE bus,BYTE dev_and_function,BYTE reg_number,BYTE *d );
int _PCI_read_cnf_word		(BYTE bus,BYTE dev_and_function,BYTE reg_number,unsigned *d );
int _PCI_read_cnf_dword		(BYTE bus,BYTE dev_and_function,BYTE reg_number,unsigned long *d );
int _PCI_err_message		(int err, char *err_mess);
int _PCI_last_err_message	(char *err_mess);


